var squirrelRegisterClass:Function = null;

public function setSquirrelRegisterClass(caller:Function):void
{
	squirrelRegisterClass = caller;
}

public function removeSquirrelRegisterClass(caller:Function):void
{
	squirrelRegisterClass = null;
}

import flash.display.Loader;
import flash.events.IOErrorEvent;
import flash.events.SecurityErrorEvent;
import flash.net.URLRequest;
import flash.system.ApplicationDomain;
import flash.system.LoaderContext;

public class ClassLoader {

	public static var NONE:String     = "none";
	public static var LOADING:String  = "loading";
	public static var COMPLETE:String = "complete";
	public static var ERROR:String    = "error";

	private var status:String;
	private var loader:Loader;

	public function ClassLoader() {
		loader = new Loader();
		loader.contentLoaderInfo.addEventListener(Event.COMPLETE,completeHandler);
		loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR,errorHandler);
		loader.contentLoaderInfo.addEventListener(SecurityErrorEvent.SECURITY_ERROR,errorHandler);
    }

    public function load(lib:String):void {
		status = LOADING;
		//var context:LoaderContext = new LoaderContext();
		//context.applicationDomain = ApplicationDomain.currentDomain;
		//loader.load(new URLRequest(lib), context);
		loader.load(new URLRequest(lib));
	}
	
	public function getStatus():String {
		return status;
	}

	public function getClass(className:String):* {
		try {
			var ret:Class = loader.contentLoaderInfo.applicationDomain.getDefinition(className)  as  Class;
			if (squirrelRegisterClass) {
				squirrelRegisterClass(ret);
			}
			return ret;
		} catch (e:Error) {
		}
		return null;
	}

    private function completeHandler(e:Event):void {
		status = COMPLETE;
    }

	private function errorHandler(e:Event):void {
		status = ERROR;
    }
};
