#include <new>
#include <string.h>
#include <ctype.h>
#include <AS3.h>
#include "sqas3obj.h"
#include "sqwrapper.h"

// sqfunc.cpp 
extern SQRESULT ERROR_CREATE(HSQUIRRELVM v);
extern SQRESULT ERROR_BADINSTANCE(HSQUIRRELVM v);
extern void registerInherit(const SQChar *typeName, const SQChar *parentName);
extern void registerTypeTag(const SQChar *typeName, SQUserPointer tag);
extern SQUserPointer getInstance(HSQUIRRELVM v, SQInteger idx, const SQChar *typeName);

// ^
static const SQChar *typeName = _SC("AS3Object"); ///< ^
static const SQUserPointer ASOBJTYPETAG = (SQUserPointer)_SC("ASOBJTYPETAG"); ///< squirrel^^O
static const SQChar *asClassAttrName = _SC("asClass");

// -----------------------------------------------------------------------

sqobject::ObjectInfo AS3Object::classMap;
AS3Variant AS3Object::typeParser;

/*
 * NX̓o^ FlasȟĂяop
 */
static AS3_Val squirrelRegisterClass(void *data, AS3_Val p)
{
	AS3Variant asClassObj(p);
	HSQUIRRELVM v = sqobject::getGlobalVM();
	if (AS3Object::registerFlashClass(v, asClassObj)) {
		sq_pop(v, 1);
	}
	return NULL;
}

/**
 * NX̓o^
 * @param HSQUIRRELVM v
 */
static SQRESULT
getFlashClass(HSQUIRRELVM v)
{
	int top = sq_gettop(v);
	if (top < 2) {
		return sq_throwerror(v, _SC("invalid param"));
	}
	AS3Variant asClassObj = AS3Variant::createClass(sqobject::getString(v,2));
	if (AS3Object::registerFlashClass(v,asClassObj)) {
		return 1;
	}
	return sq_throwerror(v, _SC("invalid class name"));
}

// p
void
AS3Object::init(HSQUIRRELVM vm)
{
	classMap.initTable();
	registerInherit(typeName, SQOBJECTNAME);
	registerTypeTag(typeName, ASOBJTYPETAG);

	// ^p[T
	typeParser = AS3Variant::createClass(APPNAMESPACE "TypeParser").createInstance();

	// NXo^p\bh FlashɃoCh
	AS3Variant caller(AS3_Function(NULL,squirrelRegisterClass));
	AS3Variant::createFunction(APPNAMESPACE "setSquirrelRegisterClass").call(caller);

	sq_pushroottable(vm);

	// FlashNX擾\bh
	sq_pushstring(vm, _SC("getFlashClass"), -1);
	sq_newclosure(vm, getFlashClass, 0);
	sq_createslot(vm, -3);

	// NX[_o^
	sq_pushstring(vm, _SC("FlashClassLoader"), -1);
	AS3Variant classLoader = AS3Variant::createClass(APPNAMESPACE "ClassLoader");
	if (AS3Object::registerFlashClass(vm, classLoader)) {
		sq_createslot(vm, -3);
	} else {
		trace("failed to register FlashClassLoader");
		sq_pop(vm,1);
	}
	
	sq_pop(vm, 1);
}

// p
void
AS3Object::done()
{
	AS3Variant::createFunction(APPNAMESPACE "removeSquirrelRegisterClass").call();
	classMap.clear();
	typeParser.clear();
}

bool
AS3Object::registerFlashClass(HSQUIRRELVM v, AS3Variant &asClassObj)
{
	if (asClassObj.isClass()) {
		AS3Variant className = asClassObj.getClassName();
		// o^ς
		//trace("getFlashClass:%s", (const char *)className);
		sqobject::ObjectInfo info = classMap.get((const char *)className);
		if (info.isClass()) {
			info.push(v);
		} else {
			//trace("before create class:%d", sq_gettop(v));
			
			// NX𐶐
			sq_pushstring(v, SQOBJECTNAME, -1);
			sq_get(v,-3);
			sq_newclass(v, true); // p
			sq_settypetag(v, -1, ASOBJTYPETAG);

			//trace("after create class:%d", sq_gettop(v));
			
			// NX̑Soo^
			registerClass(v, asClassObj, true);
			
			// RXgN^o^
			sq_pushstring(v, _SC("constructor"), -1);
			sq_pushvariant(v, asClassObj);
			sq_newclosure(v, constructor, 1);
			sq_createslot(v, -3);
			// NX AS3NXo^
			sq_pushnull(v);
			sq_newtable(v);
			if (SQ_SUCCEEDED(sq_setattributes(v,-3))) {
				sq_pop(v,1);
				sq_pushnull(v);
				if (SQ_SUCCEEDED(sq_getattributes(v, -2))) {
					sq_pushstring(v, asClassAttrName, -1);
					sq_pushvariant(v, asClassObj);
					if (SQ_SUCCEEDED(sq_createslot(v, -3))) {
						sq_pop(v,1);
					} else {
						sq_pop(v,2);
					}
				} else {
					// XXX
					sq_pop(v,1);
				}
			} else {
				// XXX
				sq_pop(v,2);
			}

			//trace("after register methods:%d", sq_gettop(v));
			
			// 쐬NXNXƂ킹ċL^
			sqobject::ObjectInfo info = sqobject::ObjectInfo(v,-1); 
			classMap.create((const char*)className, info);
		}
		return true;
	}
	return false;
}

/**
 * squirrel AS3CX^X擾
 */
bool
AS3Object::getInstance(HSQUIRRELVM v, SQInteger idx, AS3Variant &instance)
{
	if (sq_gettype(v, idx) == OT_CLASS) {
		if (idx < 0) {
			idx = sq_gettop(v) + 1 + idx;
		}
		bool ret = false;
		// NXIuWFNgo
		sq_pushnull(v);
		if (SQ_SUCCEEDED(sq_getattributes(v, idx))) {
			sq_pushstring(v, asClassAttrName, -1);
			if (SQ_SUCCEEDED(sq_get(v,-2))) {
				instance = createVariant(v, -1);
				ret = true;
				sq_pop(v,1);
			}
			sq_pop(v,1);
		} else {
			// XXX
			sq_pop(v,1);
		}
		return ret;
	} else if (sq_gettype(v, idx) == OT_INSTANCE) {
		AS3Object *obj = (AS3Object*)::getInstance(v, idx, typeName);
		if (obj) {
			instance = obj->instance;
			return true;
		}
	}
	return false;
}

/**
 * ggIuWFNg squirrel ɓo^B
 * o^ς݃NX̏ꍇ͂̃NX̃CX^XƂĂݏグ
 * @return o^
 */
bool
AS3Object::pushInstance(HSQUIRRELVM v, AS3Variant &instance)
{
	if (instance.isClass()) {
		AS3Variant className = instance.getClassName();
		//trace("push Class type:%s", (const char*)className);
		sqobject::ObjectInfo info = classMap.get((const char *)className);
		if (info.isClass()) {
			info.push(v);
			return true;
		}
	} else if (instance.isObject()) {
		AS3Variant className = instance.getClassName();
		//trace("pushInstance type:%s %d", (const char*)className, sq_gettop(v));
		// vNXo^ς݂H
		sqobject::ObjectInfo info = classMap.get((const char *)className);
		if (info.isClass()) {
			// NX push
			info.push(v);
			if (SQ_SUCCEEDED(sq_createinstance(v, -1))) {
				// CX^X𐶐
				AS3Object *obj = (AS3Object*)sq_malloc(sizeof *obj);
				new (obj) AS3Object(v, instance);
				if (SQ_SUCCEEDED(sq_setinstanceup(v, -1, obj))) {
					sq_setreleasehook(v, -1, release);
					sq_remove(v, -2);
					return true;
				} else {
					sq_pop(v,1);
					delete obj;
				}
			}
			sq_pop(v,1);
		}
		//trace("instance failed done:%d", sq_gettop(v));
	}
	return false;
}

// -----------------------------------------------------------------------

// RXgN^
AS3Object::AS3Object(HSQUIRRELVM v) : instance(NULL)
{
	initSelf(v);
}

// RXgN^BlԂꍇp
AS3Object::AS3Object(HSQUIRRELVM v, AS3Variant &instance) : instance(NULL)
{
	this->instance = instance;
	initSelf(v, -1);
}

// fXgN^
AS3Object::~AS3Object()
{
}

/**
 * IuWFNg̃[T
 */
SQRESULT
AS3Object::release(SQUserPointer up, SQInteger size)
{
	AS3Object *self = (AS3Object*)up;
	if (self) {
		self->destructor();
		self->~AS3Object();
		sq_free(self, sizeof *self);
	}
	return SQ_OK;
}

/**
 * TJSIuWFNg̃RXgN^
 * 1 IuWFNg
 * 2` 
 * Rϐ1 NXIuWFNg
 */
SQRESULT
AS3Object::constructor(HSQUIRRELVM v)
{
	//trace("call AS3Object constuructor!!");
	int top = sq_gettop(v);
	AS3Object *self = (AS3Object*)sq_malloc(sizeof *self);
	if (self) {
		new (self) AS3Object(v);
		SQUserPointer up = (sqobject::Object*)self;
		if (SQ_SUCCEEDED(sq_setinstanceup(v, 1, up))) {
			sq_setreleasehook(v, 1, release);
			AS3Variant asClassObj = createVariant(v, top);
			AS3Variant args = createArray(v, 2, top-1);
			self->instance = asClassObj.createInstance(&args);
			return SQ_OK;
		} else {
			delete self;
		}
	}
	return ERROR_CREATE(v);
}

/**
 * TJSIuWFNgp̃\bh
 * 1 IuWFNg
 * 2` 
 * Rϐ1 o
 */
SQRESULT
AS3Object::invoker(HSQUIRRELVM v)
{
	//trace("call invoker:%s", sqobject::getString(v,-1));
	AS3Variant instance;
	if (getInstance(v,1,instance)) {
		AS3Variant args = createArray(v, 2, sq_gettop(v)-1);
		AS3Variant ret = instance.callMethod(sqobject::getString(v,-1), &args);
		return sq_pushvariant(v, ret);
	}
	return ERROR_BADINSTANCE(v);
}

/**
 * TJSIuWFNgp̃vpeBQb^[
 * 1 IuWFNg
 * Rϐ1 vpeB
 */
SQRESULT
AS3Object::getter(HSQUIRRELVM v)
{
	//trace("call getter:%s", sqobject::getString(v,-1));
	AS3Variant instance;
	if (getInstance(v,1,instance)) {
		AS3Variant ret = instance.get(sqobject::getString(v, -1));
		return ret.isUndefined() ? SQ_ERROR : sq_pushvariant(v, ret);
	}
	return ERROR_BADINSTANCE(v);
}

/**
 * TJSIuWFNgp̃vpeBZb^[
 * 1 IuWFNg
 * 2 ݒl
 * Rϐ1 vpeB
 */
SQRESULT
AS3Object::setter(HSQUIRRELVM v)
{
	//trace("call setter:%s", sqobject::getString(v,-1));
	AS3Variant instance;
	if (getInstance(v,1,instance)) {
		AS3Variant value = createVariant(v,2);
		instance.set(sqobject::getString(v, -1), value);
		return SQ_OK;
	}
	return ERROR_BADINSTANCE(v);
}

/**
 * TJSIuWFNgp̃\bh
 * 1 IuWFNg
 * 2` 
 * Rϐ1 NXIuWFNg
 * Rϐ2 o
 */
SQRESULT
AS3Object::staticInvoker(HSQUIRRELVM v)
{
	AS3Variant asClassObj = createVariant(v, -2);
	AS3Variant args = createArray(v, 2, sq_gettop(v)-2);
	AS3Variant ret = asClassObj.callMethod(sqobject::getString(v,-1), &args);
	return sq_pushvariant(v, ret);
}

/**
 * TJSIuWFNgp̃vpeBQb^[
 * 1 IuWFNg
 * Rϐ1 NXIuWFNg
 * Rϐ2 vpeB
 */
SQRESULT
AS3Object::staticGetter(HSQUIRRELVM v)
{
	AS3Variant asClassObj= createVariant(v, -2);
	AS3Variant ret = asClassObj.get(sqobject::getString(v, -1));
	return ret.isUndefined() ? SQ_ERROR : sq_pushvariant(v, ret);
}
	
/**
 * TJSIuWFNgp̃vpeBZb^[
 * 1 IuWFNg
 * 2 ݒl
 * Rϐ1 NXIuWFNg
 * Rϐ2 vpeB
 */
SQRESULT
AS3Object::staticSetter(HSQUIRRELVM v)
{
	AS3Variant asClassObj = createVariant(v, -2);
	asClassObj.set(sqobject::getString(v, -1), createVariant(v, 2));
	return SQ_OK;
}

// NXo^Jn
void
AS3Object::registerClass(HSQUIRRELVM v, AS3Variant &asClassObj, bool first)
{
	AS3Variant typeinfo = typeParser.callMethod("getTypeInfo", asClassObj);
	//trace("get typeinfo");
	if (typeinfo.isObject()) {
		int length = typeinfo.get("length");
		//trace("get typeinfo count:%d", length);
		for (int i=0;i<length;i++) {
			AS3Variant info = typeinfo.get(i);
			switch ((int)info.get(0)) {
			case 1: // class
				if (first) {
					AS3Variant parentClass = AS3Variant::createClass(info.get(1));
					registerClass(v, parentClass, false);
				}
				break;
			case 2: // static property
				if (first) {
					registerProperty(v, &asClassObj, info.get(1), info.get(2));
				}
				break;
			case 3: // static method
				if (first) {
					registerFunction(v, &asClassObj, info.get(1));
				}
				break;
			case 4: // property
				registerProperty(v, NULL, info.get(1), info.get(2));
				break;
			case 5: // method
				registerFunction(v, NULL, info.get(1));
				break;
			}
		}
	}
}

// t@NVo^
void
AS3Object::registerFunction(HSQUIRRELVM v, AS3Variant *asClassObj, const char *functionName)
{
	//trace("%d:register function:%s", sq_gettop(v), functionName);
	sq_pushstring(v, functionName, -1);
	sq_pushstring(v, functionName, -1);
	if (asClassObj) {
		sq_pushvariant(v, *asClassObj);
		sq_newclosure(v, staticInvoker, 2);
	} else {
		sq_newclosure(v, invoker, 1);
	}
	sq_createslot(v, -3);
}

// vpeBo^
void
AS3Object::registerProperty(HSQUIRRELVM v, AS3Variant *asClassObj, const char *propertyName, int type)
{
	//trace("%d:register property:%s %d", sq_gettop(v), propertyName, type);
	int slen = strlen(propertyName) + 3;
	char *name = (char*)sq_malloc(slen+1);
	if (name) {
		
		name[1] = 'e';
		name[2] = 't';
		name[3] = toupper(*propertyName);
		strcpy(name+4, propertyName+1);

		if ((type & PROPERTY_WRITE)) {
			name[0] = 's';
			//trace(" add setter:%s %s", name, propertyName);
			sq_pushstring(v, name, slen);
			sq_pushstring(v, propertyName, -1);
			if (asClassObj) {
				//trace("register static prop");
				sq_pushvariant(v, *asClassObj);
				sq_newclosure(v, staticSetter, 2);
			} else {
				//trace("register normal prop");
				sq_newclosure(v, setter, 1);
			}
			sq_createslot(v, -3);
		}
		
		if ((type & PROPERTY_READ)) {
			name[0] = 'g';
			//trace(" add getter:%s %s", name, propertyName);
			sq_pushstring(v, name, slen);
			sq_pushstring(v, propertyName, -1);
			if (asClassObj) {
				//trace("register static prop");
				sq_pushvariant(v, *asClassObj);
				sq_newclosure(v, staticGetter, 2);
			} else {
				//trace("register normal prop");
				sq_newclosure(v, getter, 1);
			}
			sq_createslot(v, -3);
		}

		sq_free(name, slen+1);
	}
}
