#include <new>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <squirrel.h>
#include "asvariant.h"

/**
 * t@Cǂݍݗpf[^\
 */
class SQFileInfo {

public:
	SQFileInfo() : buffer(NULL), size(0) {
	}

	/// RXgN^
	SQFileInfo(const SQChar *filename, bool binary) : buffer(NULL), size(0) {
		AS3Variant URLRequest = AS3Variant::createClass("flash.net.URLRequest");
		AS3Variant URLLoader  = AS3Variant::createClass("flash.net.URLLoader");
		loader = URLLoader.createInstance();
		if (binary) {
			loader.set("dataFormat", AS3Variant("binary"));
		}
		loader.callMethod("load", URLRequest.createInstance(filename));
	}

	/// fXgN^
	~SQFileInfo() {
		if (buffer) {
			free(buffer);
		}
	}

	/// @return ǂݍ݊ true
	bool check() {
		AS3Variant binary("binary");
		AS3Variant text("text");
		
		AS3Variant data = loader.get("data");
		if (data.isUndefined()) {
			// ܂ǂݍ݊ĂȂ
			return false;
		}
		AS3Variant format = loader.get("dataFormat");
		if (format == binary) {
			// oCi
			size = loader.get("bytesTotal");
			buffer = (char*)malloc(size);
			data.readBytes(buffer, size);
		} else if (format == text) {
			// eLXg
			buffer = (char*)data;
			if (buffer) {
				size = strlen(buffer);
			}
		} else {
			// ȊO͖
			AS3Variant msg("not binary/text data");
			msg.trace();
		}

		return true;
	}

	/// @return obt@
	const char *getBuffer() {
		return (const char*)buffer;
	}

	/// @return TCY
	int getSize() {
		return (int)size;
	}

private:
	AS3Variant loader; ///< URLLoader
	char *buffer; ///< ̓f[^̃obt@
	int size;   ///< ǂݍ݃TCY
	bool binary;
};

/**
 * t@C񓯊ɊJ
 * @param filename XNvgt@C
 * @param binary oCiwŊJ
 * @return t@Cnh
 */
void *sqobjOpenFile(const SQChar *filename, bool binary)
{
	//printf("openFile:%s\n", filename);
	SQFileInfo *info = (SQFileInfo*)sq_malloc(sizeof *info);
	new (info) SQFileInfo(filename, binary);
	return (void*)info;
}

/**
 * t@CJꂽǂ̃`FbN
 * @param handler t@Cnh
 * @param dataPtr f[^i[AhX(o)
 * @param dataSize f[^TCY(o)
 * @return [hĂ true
 */
bool sqobjCheckFile(void *handler, const char **dataAddr, int *dataSize)
{
	SQFileInfo *file = (SQFileInfo*)handler;
	if (file) {
		if (file->check()) {
			//printf("checkFileDone\n");
			*dataAddr = file->getBuffer();
			*dataSize = file->getSize();
			return true;
		} else {
			return false;
		}
	} else {
		*dataAddr = NULL;
		*dataSize = 0;
		return true;
	}
}

/**
 * t@C
 * @param handler t@Cnh
 */
void sqobjCloseFile(void *handler)
{
	SQFileInfo *file = (SQFileInfo*)handler;
	if (file) {
		file->~SQFileInfo();
		sq_free(file, sizeof *file);
	}
}
